#include <iostream>

using namespace std;

struct Time {
  int h;
  int m;
  Time() {
    h = m = 0;
  }
  Time(int x, int y) {
    h = x;
    m = y;
  }
};

int TimeGetH(Time t) {
  return t.h;
}

int TimeGetM(Time t) {
  return t.m;
}

Time difftime(Time t1, Time t2) {
  int rh, rm; 
  if (t1.m < t2.m) {
    t1.h += -1;
    t1.m += 60;
  }
  Time r = Time(t1.h - t2.h, t1.m - t2.m);
  return r;
}

// Definizione dei tipi (implementazione non specificata) 
 typedef struct Coda_ Coda;
 typedef struct Coda_ * CodaPtr;

 // Metodi del tipo di dato astratto Coda FIFO
 // Verifica se la coda  vuota o no
 bool CodaIsEmpty(CodaPtr p);

 // Inserisce l'elemento d nella coda 
 // aumentandone la dimensione
 void Put(CodaPtr p, int d);
 
 // Rimuove un elemento dalla coda,
 // diminuendone la dimensione
 Time Get(CodaPtr p);


struct node {
  Time data;
  node * next;
  node(Time x, node * n) {
    data = x; next = n;
  }
};

struct Coda_ {
  node * head;
  node * tail;
  Coda_ () {
    head = NULL; tail = NULL;
  }
};

bool CodaIsEmpty(CodaPtr p) {
  if (p->head == NULL) return true;
  return false;
}

void Put(CodaPtr p, Time x) {
  node * t = p->tail;
  p->tail = new node(x, NULL);
  if (p->head == NULL) p->head = p->tail;
  else t->next = p->tail; 
}

Time Get(CodaPtr p) {
  Time r = p->head->data;
  node * t = p->head->next;
  delete p->head;
  p->head = t;
  return r;
}

Time Top(CodaPtr q) {
    return q->head->data;
}

void LeggiAgenda(CodaPtr q) { 
  int h, m;
  cout << "Inserire ora prima intervista: ";
  cin >> h;
  cout << "Inserire minuti prima intervista: ";
  cin >> m;
  Time inttime;
  if (TimeGetH(inttime) < 17) 
    inttime = Time(h,m);
  else
    inttime = Time(h,0);
  Put(q, inttime);
  while( TimeGetH(inttime) < 17 ) {
    cout << "Inserire ora prossima intervista: ";
    cin >> h;
    cout << "Inserire minuti prossima intervista: ";
    cin >> m;
    inttime = Time(h,m);
    if (TimeGetH(inttime) < 17) 
      inttime = Time(h,m);
    else
      inttime = Time(h,0);
    Put(q, inttime);
  }
}

void StampaAgenda(CodaPtr q) {
   while( ! CodaIsEmpty(q) ) {
     Time t = Get(q);
     
     cout << TimeGetH(t) << ":" << TimeGetM(t) << "    " ;
     if (CodaIsEmpty(q) ) {
       Time t1 = difftime(Time(17,0), t); 
       cout << TimeGetH(t1) << ":" << TimeGetM(t1) << endl;
     }
     else {
       Time t1 = difftime(Top(q), t); 
       cout << TimeGetH(t1) << ":" << TimeGetM(t1) << endl;
     }
  }
}
 
int main() {
   CodaPtr q = new Coda();

   LeggiAgenda(q);

   cout << "Appuntamento     ";
   cout  << " Tempo disponibile intervista ";
   cout  << endl;
   StampaAgenda(q);

   delete q;
 }
