#include <iostream>

using namespace std;

// Definizione dei tipi (implementazione non specificata) 
 typedef struct Coda_ Coda;
 typedef struct Coda_ * CodaPtr;

 // Metodi del tipo di dato astratto Coda FIFO
 // Verifica se la coda  vuota o no
 bool CodaIsEmpty(CodaPtr p);

 // Inserisce l'elemento d nella coda 
 // aumentandone la dimensione
 void Put(CodaPtr p, int d);
 
 // Rimuove un elemento dalla coda,
 // diminuendone la dimensione
 int Get(CodaPtr p);

struct Coda_ {
  int N; 
  int head; 
  int tail;
  int * s;
  Coda_ (int X) {
    N = X + 1;
    head = X + 1;
    tail = 0;
    s = new int[X+1];
  }
};

bool CodaIsEmpty(CodaPtr p) {
  if ((p->head % p->N) == p->tail) 
    return true;
  return false;
}

void Put(CodaPtr p, int x) {
  p->s[p->tail] = x;
  p->tail = (p->tail + 1) % p->N;
}

int Get(CodaPtr p) {
  p->head = p->head % p->N;
  int r = p->s[p->head];
  p->head = p->head + 1;
  return r;
}

int main () {
  int n;

  cout << "Insert number of elements: " ;
  cin >> n;

  CodaPtr q = new Coda(n);
  cout << "----------------------------------------" << endl;
  for( ; n > 0; n--) {
    int d = (rand() % 1000);
    cout << "Put(" << d << ")" << endl;
    Put(q, d);
  }
  cout << "----------------------------------------" << endl;
  while(!CodaIsEmpty(q)) {
    int d = Get(q);
    cout << "Pop() = " << d << endl;
  }
}
