#include <iostream>

using namespace std;

// Definizione dei tipi (implementazione non specificata) 
 typedef struct Coda_ Coda;
 typedef struct Coda_ * CodaPtr;

 // Metodi del tipo di dato astratto Coda FIFO
 // Verifica se la coda  vuota o no
 bool CodaIsEmpty(CodaPtr p);

 // Inserisce l'elemento d nella coda 
 // aumentandone la dimensione
 void Put(CodaPtr p, int d);
 
 // Rimuove un elemento dalla coda,
 // diminuendone la dimensione
 int Get(CodaPtr p);


struct node {
  int data;
  node * next;
  node(int x, node * n) {
    data = x; next = n;
  }
};

struct Coda_ {
  node * head;
  node * tail;
  Coda_ () {
    head = NULL; tail = NULL;
  }
};

bool CodaIsEmpty(CodaPtr p) {
  if (p->head == NULL) return true;
  return false;
}

void Put(CodaPtr p, int x) {
  node * t = p->tail;
  p->tail = new node(x, NULL);
  if (p->head == NULL) p->head = p->tail;
  else t->next = p->tail; 
}

int Get(CodaPtr p) {
  int r = p->head->data;
  node * t = p->head->next;
  delete p->head;
  p->head = t;
  return r;
}

int main () {
  int n;

  cout << "Insert number of elements: " ;
  cin >> n;

  CodaPtr q = new Coda();
  cout << "----------------------------------------" << endl;
  for( ; n > 0; n--) {
    int d = (rand() % 1000);
    cout << "Put(" << d << ")" << endl;
    Put(q, d);
  }
  cout << "----------------------------------------" << endl;
  while(!CodaIsEmpty(q)) {
    int d = Get(q);
    cout << "Pop() = " << d << endl;
  }
}
