#include <iostream>
#include <cstring>
using namespace std;

// Definizione dei tipi (implementazione non specificata) 
typedef struct StackChar_ StackChar;
typedef struct StackChar_ * StackCharPtr;

// Metodi del tipo di dato astratto StackChar
// Verifica se lo stack e' vuoto o no
bool StackCharIsEmpty(StackCharPtr);

 // Inserisce l'elemento d nello stack 
 // aumentandone la dimensione
void PushChar(StackCharPtr, char);
 
 // Rimuove un elemento dallo stack,
 // diminuendone la dimensione
char PopChar(StackCharPtr p);

void error(const char *);

struct nodeC {
   char data;
   nodeC * next;
   nodeC(char x, nodeC * n) {
       data = x; next = n;
   }
 };

// implementazione
struct StackChar_ {
   nodeC * s;
   StackChar_ () {
    s = NULL;
   }
 };

bool StackCharIsEmpty(StackCharPtr p) {
   if (p->s == NULL) return true;
   return false;
}

char PopChar(StackCharPtr p) {
  if (p->s == NULL) 
    error("Attempting to remove an elelement from empty stack");
  char r = p->s->data;
  nodeC * t = p->s;
  p->s = p->s->next;
  delete t;
  return r;
}

void PushChar(StackCharPtr p, char x) {
  p->s = new nodeC(x, p->s);
}

// Definizione dei tipi (implementazione non specificata) 
typedef struct StackInt_ StackInt;
typedef struct StackInt_ * StackIntPtr;

// Metodi del tipo di dato astratto StackInt
// Verifica se lo stack e' vuoto o no
bool StackIntIsEmpty(StackIntPtr);

 // Inserisce l'elemento d nello stack 
 // aumentandone la dimensione
void Push(StackIntPtr, char);
 
 // Rimuove un elemento dallo stack,
 // diminuendone la dimensione
char Pop(StackIntPtr p);

void error(const char *);

struct nodeI {
   int data;
   nodeI * next;
   nodeI(int x, nodeI * n) {
       data = x; next = n;
   }
 };

// implementazione
struct StackInt_ {
   nodeI * s;
   StackInt_ () {
    s = NULL;
   }
 };

bool StackIntIsEmpty(StackIntPtr p) {
   if (p->s == NULL) return true;
   return false;
}

int PopInt(StackIntPtr p) {
  if (p->s == NULL) 
    error("Attempting to remove an elelement from empty stack");
  int r = p->s->data;
  nodeI * t = p->s;
  p->s = p->s->next;
  delete t;
  return r;
}

void PushInt(StackIntPtr p, int x) {
  p->s = new nodeI(x, p->s);
}

void error(const char * s) {
  cerr << s << endl;
  exit(1);
}

char * get_infissa2postfissa(const char * e) {
  StackCharPtr S = new StackChar();
  int i = 0;
  // allochiamo un array di char per la stringa risultato
  // notare che qui abbondiamo di lunghezza
  char * infix = new char [strlen(e) + 1];
  int s = 0;
  for (i = 0; e[i] != '\0'; i++) {
    if ((e[i] == '(') || (e[i] == ' ')) continue;
    if (e[i] == ')') {
      infix[s++] = PopChar(S);
      infix[s++] = ' ';
    }
    if ((e[i] == '+') || (e[i] == '*'))
      PushChar(S, e[i]);
    if ((e[i] >= '0') && (e[i] <= '9')) {
      while( (e[i] >= '0') && (e[i] <= '9'))
	infix[s++] = e[i++];
      infix[s++] = ' ';
      i--; // otherwise we will loose a char
    }
  }
  infix[s] = '\0';
  delete S;
  return infix;
}

int evalpostfissa(const char * e) {
  StackIntPtr S = new StackInt();
  int i = 0;
  for (i = 0; e[i] != '\0'; i++) {
    if (e[i] == ' ') continue;
    if (e[i] == '+')
      PushInt(S, PopInt(S) + PopInt(S));
    if (e[i] == '*') {
      PushInt(S, PopInt(S) * PopInt(S));
    }
    if ((e[i] >= '0') && (e[i] <= '9')) {
      PushInt(S, 0);  
    }
    // conversione da stringa ascii al corrispondente numero
    while(( e[i] != '\0') && (e[i] >= '0') && (e[i] <= '9')) {
      int r = 10 * PopInt(S) + (e[i++] - '0');
      PushInt(S, r);
    }
  }
  int res = PopInt(S);
  delete S;
  return res;
}


int main (int argc, char ** argv) {
  if (argc != 2) {
    cerr << "Usage: " << argv[0] << " \"<expr>\"" << endl;
    exit(1);
  }
  char * stringa = new char [strlen(argv[1]) + 1];

  strcpy(stringa, argv[1]);
  
  char * infix = get_infissa2postfissa(stringa);
  cout << "Stringa di origine = " << stringa << endl;
  cout << "Stringa risultante = \"" << infix << "\"" << endl;
  int r = evalpostfissa(infix);
  cout << "La valutazione dell'espressione infissa e': " << r << endl;

  delete infix;
  delete stringa;
}

