#include <iostream>

#include <cstdlib>

using namespace std;

struct Point {
  double x;
  double y;
  Point(double px, double py) {
    x = px;
    y = py;
  };
  Point() {
    x = y = 0.0;
  };
};

typedef struct Point * PointPtr;

double point_getX(PointPtr p) {
  return p->x;
}

double point_getY(PointPtr p) {
  return p->y;
}

double diff_dabs(double x, double y) {
  if (x > y) return x - y;
  return y - x;
}

bool sono_su_retta(PointPtr p1, PointPtr p2, PointPtr p3) {
  double px12 = diff_dabs(point_getX(p1), point_getX(p2));
  double px13 = diff_dabs(point_getX(p1), point_getX(p3));

  double py12 = diff_dabs(point_getY(p1), point_getY(p2));
  double py13 = diff_dabs(point_getY(p1), point_getY(p3));

  if (py12 == 0) return px12 == 0;
  if (py13 == 0) return px13 == 0;
  return ((px12 / py12) == (px13 / py13));
}

int main() {
  PointPtr p1 = new Point(0.0,0.0);
  PointPtr p2 = new Point(2.0,2.0);
  PointPtr p3 = new Point(1.0,1.0);
  // PointPtr p3 = new Point(1.1,1.0);

  if (sono_su_retta(p1, p2, p3) == true) {
    cout << " I tre punti giacciono su una retta" << endl;
  }
  else {
    cout << " I tre punti NON giacciono su una retta" << endl;
  }
}
    
