#include <iostream>

using namespace std;

// Definizione dei tipi (implementazione non specificata) 
typedef struct Stack_ Stack;
typedef struct Stack_ * StackPtr;

// Metodi del tipo di dato astratto Stack
// Verifica se lo stack e' vuoto o no
bool StackIsEmpty(StackPtr);

 // Inserisce l'elemento d nello stack 
 // aumentandone la dimensione
void Push(StackPtr, int);
 
 // Rimuove un elemento dallo stack,
 // diminuendone la dimensione
int Pop(StackPtr p);

void error(const char *);

// implementazione
struct Stack_ {
   int N;
   int dim;
   int * s;
   Stack_ (int X) {
      N = 0;
      dim = X;
      s = new int[X];
   }
};

bool StackIsEmpty(StackPtr p) {
   if (p->N == 0) return true;
   return false;
}

int Pop(StackPtr p) {
  if (p->N == 0) 
    error("Attempting to remove an elelement from empty stack");
  p->N = p->N - 1;
  return p->s[p->N];
}

void Push(StackPtr p, int x) {
  if (p->N >= p->dim) 
     error("Out of stack dimension");
   p->s[p->N] = x;
   p->N = p->N + 1;
}

void error(const char * s) {
  cerr << s << endl;
  exit(1);
}

int main () {
  int n;

  cout << "Insert number of elements: " ;
  cin >> n;

  StackPtr s = new Stack(n);
  cout << "----------------------------------------" << endl;
  for( ; n > 0; n--) {
    int d = (rand() % 1000);
    cout << "Push(" << d << ")" << endl;
    Push(s, d);
  }
  cout << "----------------------------------------" << endl;
  while(!StackIsEmpty(s)) {
    int d = Pop(s);
    cout << "Pop() = " << d << endl;
  }
  delete s;
}

