#include <iostream>

using namespace std;

// Definizione dei tipi (implementazione non specificata) 
typedef struct Stack_ Stack;
typedef struct Stack_ * StackPtr;

// Metodi del tipo di dato astratto Stack
// Verifica se lo stack e' vuoto o no
bool StackIsEmpty(StackPtr);

 // Inserisce l'elemento d nello stack 
 // aumentandone la dimensione
void Push(StackPtr, char);
 
 // Rimuove un elemento dallo stack,
 // diminuendone la dimensione
int Pop(StackPtr p);

void error(const char *);

struct node {
   int data;
   node * next;
   node(int x, node * n) {
       data = x; next = n;
   }
 };

// implementazione
struct Stack_ {
   node * s;
   Stack_ () {
    s = NULL;
   }
 };

bool StackIsEmpty(StackPtr p) {
   if (p->s == NULL) return true;
   return false;
}

int Pop(StackPtr p) {
  if (p->s == NULL) 
    error("Attempting to remove an elelement from empty stack");
  int r = p->s->data;
  node * t = p->s;
  p->s = p->s->next;
  delete t;
  return r;
}

void Push(StackPtr p, int x) {
  p->s = new node(x, p->s);
}

void error(const char * s) {
  cerr << s << endl;
  exit(1);
}

bool uncouple( StackPtr s, int c) {
  StackPtr s1 = new Stack(); 
  bool result = false;

  while ((! StackIsEmpty(s)) && (result == false)) {
    int r = Pop(s); 
    if (r == c) { 
      result = true;
      break;
    }
    else {
      Push(s1, r);
    }
 }
 while(! StackIsEmpty(s1)) {
    int r = Pop(s1);
    Push(s, r);
 }
 delete s1;
 return result;
}

int main () {
  int n;
  int d;

  cout << "Insert number of elements: " ;
  cin >> n;

  StackPtr s = new Stack();
  cout << "----------------------------------------" << endl;
  for( ; n > 0; n--) {
    cout << "Insert first element: " ;
    cin >> d;
    cout << "Push(" << d << ")" << endl;
    Push(s, d);
  }
  cout << "----------------------------------------" << endl;
  
  cout << "Insert element to uncouple (-1 to stop): ";
  cin >> d;
  while( d != -1) {
    if (uncouple(s, d) == true) {
      cout << "Uncoupled element " << d << endl;
    }
    else {
      cout << "Attempting to uncouple missing element " << d << endl;
    }
    cout << "Insert element to uncouple (-1 to stop): ";
    cin >> d;
  }
}

